---
title: CanvasRenderingContext2D.stroke()
slug: Web/API/CanvasRenderingContext2D/stroke
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.stroke()</code></strong> method of the Canvas 2D API strokes (outlines) the current or given path with the current stroke style.</p>

<p>Strokes are aligned to the center of a path; in other words, half of the stroke is drawn on the inner side, and half on the outer side.</p>

<p>The stroke is drawn using the <a href="http://en.wikipedia.org/wiki/Nonzero-rule">non-zero winding rule</a>, which means that path intersections will still get filled.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>ctx</em>.stroke();
void <em>ctx</em>.stroke(<em>path</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>path</code></dt>
 <dd>A {{domxref("Path2D")}} path to stroke.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="A_simple_stroked_rectangle">A simple stroked rectangle</h3>

<p>This example creates a rectangle using the <code>rect()</code> method, and then draws it to the canvas using <code>stroke()</code>.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[4]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');
ctx.rect(10, 10, 150, 100);
ctx.stroke();
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('A_simple_stroked_rectangle', 700, 180) }}</p>

<h3 id="Re-stroking_paths">Re-stroking paths</h3>

<p>Typically, you'll want to call {{domxref("CanvasRenderingContext2D.beginPath()", "beginPath()")}} for each new thing you want to stroke. If you don't, the previous sub-paths will remain part of the current path, and get stroked every time you call the <code>stroke()</code> method. In some cases, however, this may be the desired effect.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<p>This code strokes the first path three times, the second path two times, and the third path only once.</p>

<pre class="brush: js; highlight:[9,16,23]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// First sub-path
ctx.lineWidth = 26;
ctx.strokeStyle = 'orange';
ctx.moveTo(20, 20);
ctx.lineTo(160, 20);
ctx.stroke();

// Second sub-path
ctx.lineWidth = 14;
ctx.strokeStyle = 'green';
ctx.moveTo(20, 80);
ctx.lineTo(220, 80);
ctx.stroke();

// Third sub-path
ctx.lineWidth = 4;
ctx.strokeStyle = 'pink';
ctx.moveTo(20, 140);
ctx.lineTo(280, 140);
ctx.stroke();
</pre>

<h4 id="Result_2">Result</h4>

<p>{{ EmbedLiveSample('Re-stroking_paths', 700, 180) }}</p>

<h3 id="Stroking_and_filling">Stroking and filling</h3>

<p>If you want to both stroke and fill a path, the order in which you perform these actions will determine the result. In this example, the square on the left is drawn with the stroke on top of the fill. The square on the right is drawn with the fill on top of the stroke.</p>

<h4 id="HTML_3">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript_3">JavaScript</h4>

<pre class="brush: js">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

ctx.lineWidth = 16;
ctx.strokeStyle = 'red';

// Stroke on top of fill
ctx.beginPath();
ctx.rect(25, 25, 100, 100);
ctx.fill();
ctx.stroke();

// Fill on top of stroke
ctx.beginPath();
ctx.rect(175, 25, 100, 100);
ctx.stroke();
ctx.fill();</pre>

<h4 id="Result_3">Result</h4>

<p>{{ EmbedLiveSample('Stroking_and_filling', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-stroke", "CanvasRenderingContext2D.stroke")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.stroke")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
</ul>
